diff --git a/hardware/openzwave/command_classes/Hail.h b/hardware/openzwave/command_classes/Hail.h
index 2ada4cba92..3c1959e1bd 100644
--- a/hardware/openzwave/command_classes/Hail.h
+++ b/hardware/openzwave/command_classes/Hail.h
@@ -33,6 +33,7 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_HAIL (0x82), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Hail: public CommandClass
 	{
diff --git a/hardware/openzwave/command_classes/Indicator.h b/hardware/openzwave/command_classes/Indicator.h
index c398257ef5..f5b049d9d9 100644
--- a/hardware/openzwave/command_classes/Indicator.h
+++ b/hardware/openzwave/command_classes/Indicator.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueByte;
 
 	/** \brief Implements COMMAND_CLASS_INDICATOR (0x87), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Indicator: public CommandClass
 	{
@@ -47,7 +48,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/Language.h b/hardware/openzwave/command_classes/Language.h
index de74aa5a95..d593d0bbbd 100644
--- a/hardware/openzwave/command_classes/Language.h
+++ b/hardware/openzwave/command_classes/Language.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueString;
 
 	/** \brief Implements COMMAND_CLASS_LANGUAGE (0x89), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Language: public CommandClass
 	{
@@ -47,7 +48,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/Lock.h b/hardware/openzwave/command_classes/Lock.h
index 38a19cdc5f..2249968c78 100644
--- a/hardware/openzwave/command_classes/Lock.h
+++ b/hardware/openzwave/command_classes/Lock.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueBool;
 
 	/** \brief Implements COMMAND_CLASS_LOCK (0x76), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Lock: public CommandClass
 	{
@@ -47,7 +48,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/ManufacturerProprietary.h b/hardware/openzwave/command_classes/ManufacturerProprietary.h
new file mode 100644
index 0000000000..9c4ea58f30
--- /dev/null
+++ b/hardware/openzwave/command_classes/ManufacturerProprietary.h
@@ -0,0 +1,61 @@
+//-----------------------------------------------------------------------------
+//
+//	ManufacturerProprietary.h
+//
+//	Implementation of the Z-Wave COMMAND_CLASS_PROPRIETARY
+//
+//	Copyright (c) 2010 Mal Lansell <openzwave@lansell.org>
+//
+//	SOFTWARE NOTICE AND LICENSE
+//
+//	This file is part of OpenZWave.
+//
+//	OpenZWave is free software: you can redistribute it and/or modify
+//	it under the terms of the GNU Lesser General Public License as published
+//	by the Free Software Foundation, either version 3 of the License,
+//	or (at your option) any later version.
+//
+//	OpenZWave is distributed in the hope that it will be useful,
+//	but WITHOUT ANY WARRANTY; without even the implied warranty of
+//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//	GNU Lesser General Public License for more details.
+//
+//	You should have received a copy of the GNU Lesser General Public License
+//	along with OpenZWave.  If not, see <http://www.gnu.org/licenses/>.
+//
+//-----------------------------------------------------------------------------
+
+#ifndef _ManufacturerProprietary_H
+#define _ManufacturerProprietary_H
+
+#include "command_classes/CommandClass.h"
+
+namespace OpenZWave
+{
+	/** \brief Implements COMMAND_CLASS_PROPRIETARY (0x91), a Z-Wave device command class.
+	 *  \ingroup CommandClass
+	 */
+	class ManufacturerProprietary: public CommandClass
+	{
+	public:
+		static CommandClass* Create( uint32 const _homeId, uint8 const _nodeId ){ return new ManufacturerProprietary( _homeId, _nodeId ); }
+		virtual ~ManufacturerProprietary(){}
+
+		static uint8 const StaticGetCommandClassId(){ return 0x91; }
+		static string const StaticGetCommandClassName(){ return "COMMAND_CLASS_MANUFACTURER_PROPRIETARY"; }
+
+		// From CommandClass
+		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
+		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
+		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool SetValue( Value const& _value );
+
+	private:
+		ManufacturerProprietary( uint32 const _homeId, uint8 const _nodeId ): CommandClass( _homeId, _nodeId ){}
+	};
+
+} // namespace OpenZWave
+
+#endif
+
diff --git a/hardware/openzwave/command_classes/ManufacturerSpecific.h b/hardware/openzwave/command_classes/ManufacturerSpecific.h
index 36bcd33c4e..e5bf1a528b 100644
--- a/hardware/openzwave/command_classes/ManufacturerSpecific.h
+++ b/hardware/openzwave/command_classes/ManufacturerSpecific.h
@@ -34,80 +34,47 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_MANUFACTURER_SPECIFIC (0x72), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class ManufacturerSpecific: public CommandClass
 	{
 	public:
 		static CommandClass* Create( uint32 const _homeId, uint8 const _nodeId ){ return new ManufacturerSpecific( _homeId, _nodeId ); }
-		virtual ~ManufacturerSpecific(){ UnloadProductXML(); }
+		virtual ~ManufacturerSpecific(){ }
 
 		static uint8 const StaticGetCommandClassId(){ return 0x72; }
 		static string const StaticGetCommandClassName(){ return "COMMAND_CLASS_MANUFACTURER_SPECIFIC"; }
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
+		virtual uint8 GetMaxVersion(){ return 2; }
 
-		static string SetProductDetails( Node *_node, uint16 _manufacturerId, uint16 _productType, uint16 _productId );
-		static bool LoadConfigXML( Node* _node, string const& _configXML );
+
+		void SetProductDetails( uint16 _manufacturerId, uint16 _productType, uint16 _productId );
+		bool LoadConfigXML();
 		
 		void ReLoadConfigXML();
 
+		void setLatestConfigRevision(uint32 rev);
+		void setFileConfigRevision(uint32 rev);
+		void setLoadedConfigRevision(uint32 rev);
+
+
+
+	protected:
+		virtual void CreateVars( uint8 const _instance );
+
+
 	private:
-		ManufacturerSpecific( uint32 const _homeId, uint8 const _nodeId ): CommandClass( _homeId, _nodeId ){ SetStaticRequest( StaticRequest_Values ); }
-		static bool LoadProductXML();
-		static void UnloadProductXML();
-
-		class Product
-		{
-		public:
-			Product
-			( 
-				uint16 _manufacturerId,
-				uint16 _productType,
-				uint16 _productId,
-				string const& _productName,
-				string const& _configPath
-			):	
-				m_manufacturerId( _manufacturerId ),
-				m_productType( _productType ),
-				m_productId( _productId ),
-				m_productName( _productName ),
-				m_configPath( _configPath )
-			{
-			}
-
-			int64 GetKey()const
-			{
-				return( GetKey( m_manufacturerId, m_productType, m_productId ) );
-			}
-
-			static int64 GetKey( uint16 _manufacturerId, uint16 _productType, uint16 _productId )
-			{
-				int64 key = (((int64)_manufacturerId)<<32) | (((int64)_productType)<<16) | (int64)_productId;
-				return key;
-			}
-
-			uint16 GetManufacturerId()const{ return m_manufacturerId; }
-			uint16 GetProductType()const{ return m_productType; }
-			uint16 GetProductId()const{ return m_productId; }
-			string GetProductName()const{ return m_productName; }
-			string GetConfigPath()const{ return m_configPath; }
-
-		private:
-			uint16	m_manufacturerId;
-			uint16	m_productType;
-			uint16	m_productId;
-			string	m_productName;
-			string	m_configPath;
-		};
-
-		static map<uint16,string>	s_manufacturerMap;
-		static map<int64,Product*>	s_productMap;
-		static bool					s_bXmlLoaded;
+		ManufacturerSpecific( uint32 const _homeId, uint8 const _nodeId );
+
+		uint32 m_fileConfigRevision;
+		uint32 m_loadedConfigRevision;
+		uint32 m_latestConfigRevision;
 	};
 
 } // namespace OpenZWave
diff --git a/hardware/openzwave/command_classes/Meter.h b/hardware/openzwave/command_classes/Meter.h
index bcf415d171..0f9c9b6db8 100644
--- a/hardware/openzwave/command_classes/Meter.h
+++ b/hardware/openzwave/command_classes/Meter.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueDecimal;
 
 	/** \brief Implements COMMAND_CLASS_METER (0x32), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Meter: public CommandClass
 	{
@@ -47,7 +48,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/MeterPulse.h b/hardware/openzwave/command_classes/MeterPulse.h
index a6156273b3..91990b2ca7 100644
--- a/hardware/openzwave/command_classes/MeterPulse.h
+++ b/hardware/openzwave/command_classes/MeterPulse.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueInt;
 
 	/** \brief Implements COMMAND_CLASS_METER_PULSE (0x35), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class MeterPulse: public CommandClass
 	{
@@ -47,7 +48,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/MultiChannelAssociation.h b/hardware/openzwave/command_classes/MultiChannelAssociation.h
index 5a48d80ffa..fd07e78bb6 100644
--- a/hardware/openzwave/command_classes/MultiChannelAssociation.h
+++ b/hardware/openzwave/command_classes/MultiChannelAssociation.h
@@ -35,6 +35,7 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_MULTI_CHANNEL_ASSOCIATION (0x8E), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class MultiChannelAssociation: public CommandClass
 	{
@@ -51,7 +52,7 @@ namespace OpenZWave
 		virtual void ReadXML( TiXmlElement const* _ccElement );
 		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );			
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );			
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }		
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
@@ -68,7 +69,6 @@ namespace OpenZWave
 		bool			m_queryAll;			// When true, once a group has been queried, we request the next one.
 		uint8			m_numGroups;		// Number of groups supported by the device.  255 is reported by certain manufacturers and requires special handling.
 		vector<InstanceAssociation>	m_pendingMembers;	// Used to build a list of group members from multiple reports
-		bool			m_alwaysSetInstance; // Should we also set a instance, even if a instance wasn't specified (for Qubino devices - See bug #857)
 			
 	};
 
diff --git a/hardware/openzwave/command_classes/MultiCmd.h b/hardware/openzwave/command_classes/MultiCmd.h
index 57e30e7381..615e2b633c 100644
--- a/hardware/openzwave/command_classes/MultiCmd.h
+++ b/hardware/openzwave/command_classes/MultiCmd.h
@@ -33,6 +33,7 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_MULTI_CMD (0x8f), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class MultiCmd: public CommandClass
 	{
diff --git a/hardware/openzwave/command_classes/MultiInstance.h b/hardware/openzwave/command_classes/MultiInstance.h
index 40873f8600..a58349907c 100644
--- a/hardware/openzwave/command_classes/MultiInstance.h
+++ b/hardware/openzwave/command_classes/MultiInstance.h
@@ -34,6 +34,7 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_MULTI_INSTANCE (0x60), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class MultiInstance: public CommandClass
 	{
@@ -54,13 +55,6 @@ namespace OpenZWave
 			MultiChannelCmd_Encap				= 0x0d
 		};
 
-		enum MultiInstanceMapping
-		{
-			MultiInstanceMapAll,
-			MultiInstanceMapEndPoints,
-			MultiInstanceMapOther
-		};
-
 		static CommandClass* Create( uint32 const _homeId, uint8 const _nodeId ){ return new MultiInstance( _homeId, _nodeId ); }
 		virtual ~MultiInstance(){}
 
@@ -70,14 +64,12 @@ namespace OpenZWave
 		bool RequestInstances();
 
 		// From CommandClass
-		virtual void ReadXML( TiXmlElement const* _ccElement );
-		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
+		virtual bool HandleIncomingMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
 		virtual uint8 GetMaxVersion(){ return 2; }
-
-		MultiInstanceMapping GetEndPointMap(){ return m_endPointMap; }
+		void SetInstanceLabel(uint8 const _instance, char *label);
 
 	private:
 		MultiInstance( uint32 const _homeId, uint8 const _nodeId );
@@ -92,18 +84,12 @@ namespace OpenZWave
 		bool		m_numEndPointsCanChange;
 		bool		m_endPointsAreSameClass;
 		uint8		m_numEndPoints;
-
+		
 		// Finding endpoints
 		uint8		m_endPointFindIndex;
 		uint8		m_numEndPointsFound;
 		set<uint8>	m_endPointCommandClasses;
 
-		// configuration
-		uint8		m_numEndPointsHint;		// for nodes that do not report correct number of end points
-		MultiInstanceMapping m_endPointMap;		// Determine how to map end points to value id instances
-		bool		m_endPointFindSupported;	// for nodes that (someday may) support endpointfind
-		bool 		m_ignoreUnsolicitedMultiChannelCapabilityReport;
-		bool		m_uniqueendpoints;
 	};
 
 } // namespace OpenZWave
diff --git a/hardware/openzwave/command_classes/NoOperation.h b/hardware/openzwave/command_classes/NoOperation.h
index fa8a76f753..16f192406f 100644
--- a/hardware/openzwave/command_classes/NoOperation.h
+++ b/hardware/openzwave/command_classes/NoOperation.h
@@ -33,6 +33,7 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_NO_OPERATION (0x00), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class NoOperation: public CommandClass
 	{
diff --git a/hardware/openzwave/command_classes/NodeNaming.h b/hardware/openzwave/command_classes/NodeNaming.h
index 4e52491462..c280599cac 100644
--- a/hardware/openzwave/command_classes/NodeNaming.h
+++ b/hardware/openzwave/command_classes/NodeNaming.h
@@ -32,7 +32,24 @@
 
 namespace OpenZWave
 {
+
+	/** \brief Extract a String from a Z-Wave Encoded Packet
+	 * \ingroup CommandClass
+	 *
+	 *  this function is used by the NodeNaming CC as well as the Alarm CC
+	 */
+	string ExtractString( uint8 const* _data, uint32 const _length );
+
+	/** \brief Convert from UTF16 to UTF8
+	 * \ingroup CommandClass
+	 *
+	 *  this function is used by the NodeNaming CC as well as the Alarm CC
+	 */
+	uint32 ConvertUFT16ToUTF8( uint16 _utf16, char* _buffer, uint32 pos );
+
+
 	/** \brief Implements COMMAND_CLASS_NODE_NAMING (0x77), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class NodeNaming: public CommandClass
 	{
@@ -45,7 +62,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }		
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
@@ -55,9 +72,6 @@ namespace OpenZWave
 
 	private:
 		NodeNaming( uint32 const _homeId, uint8 const _nodeId ): CommandClass( _homeId, _nodeId ){}
-
-		string ExtractString( uint8 const* _data, uint32 const _length );
-		uint32 ConvertUFT16ToUTF8( uint16 _utf16, char* _buffer, uint32 pos );
 	};
 
 } // namespace OpenZWave
diff --git a/hardware/openzwave/command_classes/Powerlevel.h b/hardware/openzwave/command_classes/Powerlevel.h
index 4e25ffb452..bd99e6b789 100644
--- a/hardware/openzwave/command_classes/Powerlevel.h
+++ b/hardware/openzwave/command_classes/Powerlevel.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueList;
 
 	/** \brief Implements COMMAND_CLASS_POWERLEVEL (0x73), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Powerlevel: public CommandClass
 	{
@@ -68,7 +69,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/Proprietary.h b/hardware/openzwave/command_classes/Proprietary.h
index 187af1ada5..c6044a70cf 100644
--- a/hardware/openzwave/command_classes/Proprietary.h
+++ b/hardware/openzwave/command_classes/Proprietary.h
@@ -33,6 +33,7 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_PROPRIETARY (0x88), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Proprietary: public CommandClass
 	{
diff --git a/hardware/openzwave/command_classes/Protection.h b/hardware/openzwave/command_classes/Protection.h
index 867265228c..9b71ea1aa4 100644
--- a/hardware/openzwave/command_classes/Protection.h
+++ b/hardware/openzwave/command_classes/Protection.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueList;
 
 	/** \brief Implements COMMAND_CLASS_PROTECTION (0x75), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Protection: public CommandClass
 	{
@@ -54,7 +55,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/SceneActivation.h b/hardware/openzwave/command_classes/SceneActivation.h
index b2a73716fd..c359f292e0 100644
--- a/hardware/openzwave/command_classes/SceneActivation.h
+++ b/hardware/openzwave/command_classes/SceneActivation.h
@@ -29,14 +29,16 @@
 #define _SceneActivation_H
 
 #include "command_classes/CommandClass.h"
+#include "TimerThread.h"
 
 namespace OpenZWave
 {
 	class ValueByte;
 
 	/** \brief Implements COMMAND_CLASS_SCENEACTIVATION (0x2B), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
-	class SceneActivation: public CommandClass
+	class SceneActivation: public CommandClass, private Timer
 	{
 	public:
 		static CommandClass* Create( uint32 const _homeId, uint8 const _nodeId ){ return new SceneActivation( _homeId, _nodeId ); }
@@ -53,10 +55,16 @@ namespace OpenZWave
 		/** \brief Get a string containing the name of this command class. (Inherited from CommandClass) */
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		/** \brief Handle a response to a message associated with this command class. (Inherited from CommandClass) */
+		virtual bool HandleIncommingMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
 
+	protected:
+		virtual void CreateVars( uint8 const _instance );
+
 	private:
-		SceneActivation( uint32 const _homeId, uint8 const _nodeId ): CommandClass( _homeId, _nodeId ){}
+		void ClearScene(uint32 id);
+		SceneActivation( uint32 const _homeId, uint8 const _nodeId );
+
 	};
 
 } // namespace OpenZWave
diff --git a/hardware/openzwave/command_classes/Security.h b/hardware/openzwave/command_classes/Security.h
index 799552f5cb..14efc2d75b 100644
--- a/hardware/openzwave/command_classes/Security.h
+++ b/hardware/openzwave/command_classes/Security.h
@@ -34,8 +34,6 @@
 
 namespace OpenZWave
 {
-	/** \brief Implements COMMAND_CLASS_SECURITY (0x98), a Z-Wave device command class.
-	 */
 
 
 	enum SecurityCmd
@@ -59,6 +57,9 @@ namespace OpenZWave
 	};
 
 
+	/** \brief Implements COMMAND_CLASS_SECURITY (0x98), a Z-Wave device command class.
+	 * \ingroup CommandClass
+	 */
 
 	class Security: public CommandClass
 	{
@@ -68,14 +69,12 @@ namespace OpenZWave
 
 		static uint8 const StaticGetCommandClassId(){ return 0x98; }
 		static string const StaticGetCommandClassName(){ return "COMMAND_CLASS_SECURITY"; }
-		bool Init();
+		bool Init(uint32 const _instance = 1);
 		bool ExchangeNetworkKeys();
 		// From CommandClass
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
-		void ReadXML(TiXmlElement const* _ccElement);
-		void WriteXML(TiXmlElement* _ccElement);
 		void SendMsg( Msg* _msg );
 
 	protected:
@@ -84,8 +83,8 @@ namespace OpenZWave
 	private:
 		Security( uint32 const _homeId, uint8 const _nodeId );
 		bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue);
-		bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue);
-		bool HandleSupportedReport(uint8 const* _data, uint32 const _length);
+		bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue);
+		bool HandleSupportedReport(uint8 const* _data, uint32 const _length, uint32 const _instance = 1);
 
 		bool m_schemeagreed;
 		bool m_secured;
diff --git a/hardware/openzwave/command_classes/SensorAlarm.h b/hardware/openzwave/command_classes/SensorAlarm.h
index 7f3a421fad..842ff150dc 100644
--- a/hardware/openzwave/command_classes/SensorAlarm.h
+++ b/hardware/openzwave/command_classes/SensorAlarm.h
@@ -37,6 +37,7 @@ namespace OpenZWave
 	class ValueByte;
 
 	/** \brief Implements COMMAND_CLASS_SENSOR_ALARM (0x9c), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class SensorAlarm: public CommandClass
 	{
@@ -49,7 +50,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _alarmType, uint8 const _dummy, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _alarmType, uint8 const _dummy, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/SensorBinary.h b/hardware/openzwave/command_classes/SensorBinary.h
index ac107fe726..35eb3f6265 100644
--- a/hardware/openzwave/command_classes/SensorBinary.h
+++ b/hardware/openzwave/command_classes/SensorBinary.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueBool;
 
 	/** \brief Implements COMMAND_CLASS_SENSOR_BINARY (0x30), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class SensorBinary: public CommandClass
 	{
@@ -49,7 +50,7 @@ namespace OpenZWave
 		virtual void ReadXML( TiXmlElement const* _ccElement );
 		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/SensorMultilevel.h b/hardware/openzwave/command_classes/SensorMultilevel.h
index e1ccc2ac93..b3d33ae26d 100644
--- a/hardware/openzwave/command_classes/SensorMultilevel.h
+++ b/hardware/openzwave/command_classes/SensorMultilevel.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueDecimal;
 
 	/** \brief Implements COMMAND_CLASS_SENSOR_MULTILEVEL (0x31), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class SensorMultilevel: public CommandClass
 	{
@@ -47,12 +48,12 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _dummy, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _dummy, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
-		
-		virtual uint8 GetMaxVersion(){ return 5; }
+
+		virtual uint8 GetMaxVersion(){ return 11; }
 
 	protected:
 		virtual void CreateVars( uint8 const _instance );
diff --git a/hardware/openzwave/command_classes/SimpleAV.h b/hardware/openzwave/command_classes/SimpleAV.h
new file mode 100644
index 0000000000..1433dbe3ac
--- /dev/null
+++ b/hardware/openzwave/command_classes/SimpleAV.h
@@ -0,0 +1,29 @@
+#include "command_classes/CommandClass.h"
+
+namespace OpenZWave
+{
+	/** Implements COMMAND_CLASS_SIMPLE_AV_CONTROL (0x94), a Z-Wave device command class. */
+	class SimpleAV : public CommandClass
+	{
+	public:
+		static CommandClass* Create(uint32 const _homeId, uint8 const _nodeId) { return new SimpleAV(_homeId, _nodeId); }
+		virtual ~SimpleAV() {}
+
+		static uint8 const StaticGetCommandClassId() { return 0x94; }
+		static string const StaticGetCommandClassName() { return "COMMAND_CLASS_SIMPLE_AV_CONTROL"; }
+
+		// From CommandClass
+		virtual uint8 const GetCommandClassId()const { return StaticGetCommandClassId(); }
+		virtual string const GetCommandClassName()const { return StaticGetCommandClassName(); }
+		virtual bool HandleMsg(uint8 const* _data, uint32 const _length, uint32 const _instance = 1);
+		virtual bool SetValue(Value const& _value);
+
+	protected:
+		virtual void CreateVars(uint8 const _instance);
+		
+	private:
+		SimpleAV(uint32 const _homeId, uint8 const _nodeId) : CommandClass(_homeId, _nodeId) {}
+		uint8 m_sequence;
+	};
+
+} // namespace OpenZWave
\ No newline at end of file
